#SkIndigo Ruby code is copyright Dale Martens 2009, all rights reserved.
#####################################################Indigo Render Settings Interface Class
class IndigoRenderSettings

#Defaults
@@mncr=Sketchup.read_default("SkIndigoDefaults",'mncr',1000)
@@method="Bidir PT"
#@@method=Sketchup.read_default("SkIndigoDefaults",'method',"Bidir PT")
@@halt=Sketchup.read_default("SkIndigoDefaults",'halt',-1)
@@halt_unit=Sketchup.read_default("SkIndigoDefaults",'halt_unit',"sec")
@@aperture=Sketchup.read_default("SkIndigoDefaults",'aperture',"f\/16")
@@image_save_period=Sketchup.read_default("SkIndigoDefaults",'isp',1800) # 30 mins
@@white_balance=Sketchup.read_default("SkIndigoDefaults",'wb',"D65")
@@environment=Sketchup.read_default("SkIndigoDefaults",'env',"Sun and Sky")
@@turbidity=Sketchup.read_default("SkIndigoDefaults",'tur',2.0)
@@threads=Sketchup.read_default("SkIndigoDefaults",'threads',1)
@@focal_point=Sketchup.read_default("SkIndigoDefaults",'fp',"auto")
@@save_igi=Sketchup.read_default("SkIndigoDefaults",'save_igi',"On")
@@watermark=Sketchup.read_default("SkIndigoDefaults",'watermark',"Off")
@@auto_choose_threads=Sketchup.read_default("SkIndigoDefaults",'auto_threads',"On")
@@custom_image_name=Sketchup.read_default("SkIndigoDefaults",'custom_image_name',"Off")
@@low_priority=Sketchup.read_default("SkIndigoDefaults",'low_priority',"On")
@@tm=Sketchup.read_default("SkIndigoDefaults",'tm',"Reinhard")
@@exr=Sketchup.read_default("SkIndigoDefaults",'exr',"")
@@exr_type=Sketchup.read_default("SkIndigoDefaults",'exr_type',"Lat_Long")
@@exr_width=Sketchup.read_default("SkIndigoDefaults",'exr_width',640)
@@exr_shift=Sketchup.read_default("SkIndigoDefaults",'exr_shift',0.0)
@@exr_gain=Sketchup.read_default("SkIndigoDefaults",'exr_gain',1000)
@@pre_scale=Sketchup.read_default("SkIndigoDefaults",'pre_scale',3.0)
@@post_scale=Sketchup.read_default("SkIndigoDefaults",'post_scale',1.0)
@@burn=Sketchup.read_default("SkIndigoDefaults",'burn',6.0)
@@iso=Sketchup.read_default("SkIndigoDefaults",'iso',100)
@@shutter_speed=Sketchup.read_default("SkIndigoDefaults",'shutterSpeed',100)
@@ev_adjust=Sketchup.read_default("SkIndigoDefaults",'exposure',0.0)
@@linear_scale = Sketchup.read_default("SkIndigoDefaults",'linear_scale', 1.0)
@@filmic_scale = Sketchup.read_default("SkIndigoDefaults",'filmic_scale', 1.0)
@@aperture_shape=Sketchup.read_default("SkIndigoDefaults",'ap_shape',"circular")
@@blade_offset=Sketchup.read_default("SkIndigoDefaults",'blade_offset',0.3)
@@blade_curvature_radius=Sketchup.read_default("SkIndigoDefaults",'blade_curvature_radius',0.5)
@@start_angle=Sketchup.read_default("SkIndigoDefaults",'start_angle',0.0)
@@aperture_image=Sketchup.read_default("SkIndigoDefaults",'aperture_image',"")
@@obstacle_map=Sketchup.read_default("SkIndigoDefaults",'obstacle_map',"")
@@aperture_diffraction=Sketchup.read_default("SkIndigoDefaults",'ap_diff',"Off")
@@use_obstacle_map=Sketchup.read_default("SkIndigoDefaults",'use_om',"Off")
@@region=Sketchup.read_default("SkIndigoDefaults",'region',"0.0|0.0|0.0|0.0" ) #x1,x2,y1,y2
@@render_region=Sketchup.read_default("SkIndigoDefaults",'render_region',"Off")
@@shift_up=Sketchup.read_default("SkIndigoDefaults",'shift_up',0)
@@shift_right=Sketchup.read_default("SkIndigoDefaults",'shift_right',0)
@@info_overlay=Sketchup.read_default("SkIndigoDefaults",'info_overlay',"Off")
@@supersample_factor=Sketchup.read_default("SkIndigoDefaults",'supersample_factor',2)
@@sun_layer=Sketchup.read_default("SkIndigoDefaults",'sun_layer',0)
@@sky_layer=Sketchup.read_default("SkIndigoDefaults",'sky_layer',0)
@@env_map_layer=Sketchup.read_default("SkIndigoDefaults",'env_map_layer',0)
@@model_textures=[]  #array to store paths of user textures for easier re-selection
@@frame_upload_period=Sketchup.read_default("SkIndigoDefaults",'frame_upload_period',120)
@@network_mode=Sketchup.read_default("SkIndigoDefaults",'network_mode',0) #disabled
@@cam_resp_func=Sketchup.read_default("SkIndigoDefaults",'cam_resp_func',"dscs315")
@@light_layer_names=Sketchup.read_default("SkIndigoDefaults",'layer_names',["0","1","2","3","4","5","6","7","8","9"])
@@sun_dir=[]
@@sun_dir_override=false
@@glass_accel=Sketchup.read_default("SkIndigoDefaults",'glass_accel',"Off")
@@vignetting=Sketchup.read_default("SkIndigoDefaults",'vignetting',"On")
@@bg_luminance=Sketchup.read_default("SkIndigoDefaults",'bg_luminance',8000) #TODO verify default
@@bg_weight=Sketchup.read_default("SkIndigoDefaults",'bg_weight',1.0)
@@sunsky_weight=Sketchup.read_default("SkIndigoDefaults",'sunsky_weight',0.0)
@@bg_sun=Sketchup.read_default("SkIndigoDefaults",'bg_sun',"Off")
@@lock_aspect=Sketchup.read_default("SkIndigoDefaults",'lock_aspect',"Off")
@@use_gpu=Sketchup.read_default("SkIndigoDefaults",'use_gpu',"Off")
@@sky_model=Sketchup.read_default("SkIndigoDefaults",'sky_model',"captured-simulation")
@@cull_geometry=Sketchup.read_default("SkIndigoDefaults",'cull_geometry',"On")
@@camera_type=Sketchup.read_default("SkIndigoDefaults",'camera_type',"thin-lens-perspective")
@@foreground_alpha=Sketchup.read_default("SkIndigoDefaults",'foreground_alpha',"Off")
@@clamp_contributions = Sketchup.read_default("SkIndigoDefaults",' clamp_contributions',"Off")
@@max_contribution = Sketchup.read_default("SkIndigoDefaults", 'max_contribution', 10.0)
@@gpu_max_depth = Sketchup.read_default("SkIndigoDefaults", 'gpu_max_depth', 8)

def initialize(dict=nil)
	
	@model=Sketchup.active_model
	@view=@model.active_view
	@dict="indigo07_settings"
	@path=SkIndigo.get_indigo_path
	#p self.env_map_layer
	create_bg_material_from_exr()
end

####backward compatibility routine for old environment maps
def create_bg_material_from_exr()

if self.exr!=""  #if user has defined the path to an environment map using a previous skindigo version
	mats=Sketchup.active_model.materials
	bg_mat=mats.add("IndigoBackground")
	bg_mat=IndigoMaterial.new(bg_mat)
	bg_mat.layer=@model.get_attribute(@dict,'env_map_layer',@@env_map_layer)
	be=bg_mat.base_emission
	be.spectrum_type="Blackbody"
	be.bb_temperature=5000
	be.bb_gain=0.001
	bg_mat.base_emission=be
	em=bg_mat.emission_map
	em.path=self.exr  #make the old path of the exr to the emission map path
	em.exponent=1.0
	bg_mat.emission_map=em
	bg_mat.use_emission=true
	self.bg_material=bg_mat.name
	self.bg_luminance=self.exr_gain
	self.exr=""  
end  #if

end


#calling this functino will result in all settings being stored to the current scene instead of the model
def save_to_scene(page=nil)

if page!=nil
	@model=page
	#p @model.name
	status=1
end
return status	

end

###
def saved_to_current_scene?
pages=Sketchup.active_model.pages
current_page=pages.selected_page
if current_page!=nil
	dicts=current_page.attribute_dictionaries
	if dicts and dicts["indigo07_settings"]!=nil
		return true
	else
		return false
	end
end

end

def save_to_model()
@model=Sketchup.active_model
end

def dictionary=(value)
	@dict=value
end

def IndigoRenderSettings.default_thumbnail_path
	path=SkIndigo.get_indigo_path
	if FileTest.exist?(path)
		preview_path=File.join(File.dirname(path))
		if not FileTest.exist?(preview_path)
			default_thumb_path=""
		else
			default_thumb_path=File.join(preview_path,"thumbnails")
			if not FileTest.exist?(default_thumb_path)
				Dir.mkdir(default_thumb_path)
			end
			default_thumb_path.gsub!(/\\/,"\/")
		end
	else
		default_thumb_path=""
	end
	return default_thumb_path
end

def indigo_path
	return @path
end

def mncr
	@model.get_attribute(@dict,'mncr',@@mncr)
end

def mncr=(value)
	@model.set_attribute(@dict,'mncr',value)
end

def aperture
	@model.get_attribute(@dict,'aperture',@@aperture)
end

def aperture=(value)
	@model.set_attribute(@dict,'aperture',value)
end

def method
	@model.get_attribute(@dict,'method',@@method)
end

def method=(value)
	@model.set_attribute(@dict,'method',value)
end	

def width
	@model.get_attribute(@dict,'w',@view.vpwidth/2).to_i
end

def width=(value)
	@model.set_attribute(@dict,'w',value)
end

def height
	@model.get_attribute(@dict,'h',@view.vpheight/2).to_i
end

def height=(value)
	@model.set_attribute(@dict,'h',value)
end

def halt
	@model.get_attribute(@dict,'halt',@@halt)
end

def halt=(value)
	@model.set_attribute(@dict,'halt',value)
end

def image_save_period
	@model.get_attribute(@dict,'isp',@@image_save_period)
end

def image_save_period=(value)
	@model.set_attribute(@dict,'isp',value)
end

def white_balance
	@model.get_attribute(@dict,'wb',@@white_balance)
end

def white_balance=(value)
	@model.set_attribute(@dict,'wb',value)
end

def environment
	@model.get_attribute(@dict,'env',@@environment)
end

def environment=(value)
	@model.set_attribute(@dict,'env',value)
end

def turbidity
	@model.get_attribute(@dict,'tur',@@turbidity)
end

def turbidity=(value)
	@model.set_attribute(@dict,'tur',value)
end

def num_threads
	t=@model.get_attribute(@dict,'threads',@@threads)
	t=@model.set_attribute(@dict,'threads',1) if t=="Low Priority"   #backward compatibility with old versions
	return t
end

def num_threads=(value)
	@model.set_attribute(@dict,'threads',value)
end

def focal_point
	@model.get_attribute(@dict,'fp',@@focal_point)
end

def focal_point=(value)
	@model.set_attribute(@dict,'fp',value)
end

def save_igi?
	igi=@model.get_attribute(@dict,'save_igi',@@save_igi)
	return true if igi=="On"
	return false if igi=="Off"
end

def save_igi=(value)
	if value
		@model.set_attribute(@dict,'save_igi',"On")  
	else
		@model.set_attribute(@dict,'save_igi',"Off")  
	end
end

def watermark?
	wm=@model.get_attribute(@dict,'watermark',@@watermark)
	return true if wm=="On"
	return false if wm=="Off"
end

def watermark=(value)
	if value
		@model.set_attribute(@dict,'watermark',"On")  
	else
		@model.set_attribute(@dict,'watermark',"Off") 
	end
end

def auto_choose_threads?
	act=@model.get_attribute(@dict,'auto_threads',@@auto_choose_threads)
	return true if act=="On"
	return false if act=="Off"
end

def auto_choose_threads=(value)
	if value
		@model.set_attribute(@dict,'auto_threads',"On")  
	else
		@model.set_attribute(@dict,'auto_threads',"Off") 
	end
end

def custom_image_name?
	cin=@model.get_attribute(@dict,'custom_image_name',@@custom_image_name)
	return true if cin=="On"
	return false if cin=="Off"
end

def custom_image_name=(value)
	if value
		@model.set_attribute(@dict,'custom_image_name',"On")  
	else
		@model.set_attribute(@dict,'custom_image_name',"Off") 
	end
end

def low_priority?
	lp=@model.get_attribute(@dict,'low_priority',@@low_priority)
	return true if lp=="On"
	return false if lp=="Off"
end

def low_priority=(value)
	if value
		@model.set_attribute(@dict,'low_priority',"On")  
	else
		@model.set_attribute(@dict,'low_priority',"Off") 
	end
end

def tm
	@model.get_attribute(@dict,'tm',@@tm)
end

def tm=(value)
	@model.set_attribute(@dict,'tm',value)
end
	
def image_name
	model_filename = File.basename(Sketchup.active_model.path,".skp")
	model_filename="untitled" if model_filename==""
	@model.get_attribute(@dict,'image_name',model_filename)
end

def image_name=(value)
	@model.set_attribute(@dict,'image_name',value)
end	

def halt_unit
	@model.get_attribute(@dict,'halt_unit',@@halt_unit)
end

def halt_unit=(value)
	@model.set_attribute(@dict,'halt_unit',value)
end

def exr
	@model.get_attribute(@dict,'exr',@@exr)
end

def exr=(value)
	@model.set_attribute(@dict,'exr',value)
end

def exr_type
	@model.get_attribute(@dict,'exr_type',@@exr_type)
end

def exr_type=(value)
	@model.set_attribute(@dict,'exr_type',value)
end

def exr_width
	@model.get_attribute(@dict,'exr_width',@@exr_width)
end

def exr_width=(value)
	@model.set_attribute(@dict,'exr_width',value)
end

def exr_gain
	@model.get_attribute(@dict,'exr_gain',@@exr_gain)
end

def exr_gain=(value)
	@model.set_attribute(@dict,'exr_gain',value)
end

def exr_width=(value)
	@model.set_attribute(@dict,'exr_width',value)
end

def pre_scale
	@model.get_attribute(@dict,'pre_scale',@@pre_scale)
end

def pre_scale=(value)
	@model.set_attribute(@dict,'pre_scale',value)
end

def post_scale
	@model.get_attribute(@dict,'post_scale',@@post_scale)
end

def post_scale=(value)
	@model.set_attribute(@dict,'post_scale',value)
end

def burn
	@model.get_attribute(@dict,'burn',@@burn)
end

def burn=(value)
	@model.set_attribute(@dict,'burn',value)
end	

def iso
	@model.get_attribute(@dict,'iso',@@iso)
end

def iso=(value)
	@model.set_attribute(@dict,'iso',value)
end	
	
def shutter_speed
	@model.get_attribute(@dict,'shutterSpeed',@@shutter_speed)
end

def shutter_speed=(value)
	@model.set_attribute(@dict,'shutterSpeed',value)
end

def ev_adjust
	@model.get_attribute(@dict,'exposure',@@ev_adjust)
end

def ev_adjust=(value)
	@model.set_attribute(@dict,'exposure',value)
end

def linear_scale
	@model.get_attribute(@dict,'linear_scale',@@linear_scale)
end

def linear_scale=(value)
	@model.set_attribute(@dict,'linear_scale',value)
end

def filmic_scale
	@model.get_attribute(@dict,'filmic_scale',@@filmic_scale)
end

def filmic_scale=(value)
	@model.set_attribute(@dict,'filmic_scale',value)
end

def exr_shift
	@model.get_attribute(@dict,'exr_shift',@@exr_shift)
end

def exr_shift=(value)
	@model.set_attribute(@dict,'exr_shift',value)
end

def image_path
	path = SkIndigo.get_indigo_app_data_path
	image_path = File.join(path, "renders")
	if path
		Dir.mkdir(image_path) if not FileTest.exist?(image_path)
		image_path.gsub!(/\\/,"\/")
		return image_path
	else
		return nil
	end
end

def thumbnail_path
	#thumb_path=@model.get_attribute(@dict,'thumb_path',IndigoRenderSettings.default_thumbnail_path)
	#path=File.dirname(SkIndigo.get_indigo_path)
	#path=SkIndigo.get_indigo_app_data_path
	path=SkIndigo.get_user_app_support_path
	thumb_path=File.join(path,"SUthumbnails")
	if path
		Dir.mkdir(thumb_path) if not FileTest.exist?(thumb_path)
		thumb_path.gsub!(/\\/,"\/")
		return thumb_path
	else
		return nil
	end          
end

def thumbnail_path=(value)
	@model.set_attribute(@dict,'thumb_path',value)
end

def last_path
	@model.get_attribute(@dict,'export_path')
end

def last_path=(value)
	@model.set_attribute(@dict,'export_path',value)
end

def aperture_shape
	@model.get_attribute(@dict,'ap_shape',@@aperture_shape)
end

def aperture_diffraction?
	ad=@model.get_attribute(@dict,'ap_diff',@@aperture_diffraction)
	return true if ad=="On"
	return false if ad=="Off"
end

def aperture_diffraction=(value)
	if value
		@model.set_attribute(@dict,'ap_diff',"On")  
	else
		@model.set_attribute(@dict,'ap_diff',"Off") 
	end
end

def use_obstacle_map?
	om=@model.get_attribute(@dict,'use_om',@@use_obstacle_map)
	return true if om=="On"
	return false if om=="Off"
end

def use_obstacle_map=(value)
	if value
		@model.set_attribute(@dict,'use_om',"On")  
	else
		@model.set_attribute(@dict,'use_om',"Off") 
	end
end

def aperture_shape=(value)
	@model.set_attribute(@dict,'ap_shape',value)
end

def blade_offset
	@model.get_attribute(@dict,'blade_offset',@@blade_offset)
end

def blade_offset=(value)
	@model.set_attribute(@dict,'blade_offset',value)
end

def blade_curvature_radius
	@model.get_attribute(@dict,'blade_curvature_radius',@@blade_curvature_radius)
end

def blade_curvature_radius=(value)
	@model.set_attribute(@dict,'blade_curvature_radius',value)
end

def start_angle
	@model.get_attribute(@dict,'start_angle',@@start_angle)
end

def start_angle=(value)
	@model.set_attribute(@dict,'start_angle',value)
end

def aperture_image
	@model.get_attribute(@dict,'aperture_image',@@aperture_image)
end

def aperture_image=(value)
	@model.set_attribute(@dict,'aperture_image',value)
end

def obstacle_map
	@model.get_attribute(@dict,'obstacle_map',@@obstacle_map)
end

def obstacle_map=(value)
	@model.set_attribute(@dict,'obstacle_map',value)
end

def render_region?
	rr=@model.get_attribute(@dict,'render_region',@@render_region)
	return true if rr=="On"
	return false if rr=="Off"
end

def render_region=(value)
	if value
		@model.set_attribute(@dict,'render_region',"On")
	else
		@model.set_attribute(@dict,'render_region',"Off") 
	end
end

def region=(value)
	reg=value.join("|")
	@model.set_attribute(@dict,'region',reg)
end

def region
	reg=@model.get_attribute(@dict,'region',@@region)
	return reg.split("|")
end

def shift_up
	@model.get_attribute(@dict,'shift_up',@@shift_up)
end

def shift_up=(value)
	@model.set_attribute(@dict,'shift_up',value)
end

def shift_right
	@model.get_attribute(@dict,'shift_right',@@shift_right)
end

def shift_right=(value)
	@model.set_attribute(@dict,'shift_right',value)
end

def info_overlay=(value)
	if value
		@model.set_attribute(@dict,'info_overlay',"On")
	else
		@model.set_attribute(@dict,'info_overlay',"Off") 
	end
end

def info_overlay?
	io=@model.get_attribute(@dict,'info_overlay',@@info_overlay)
	return true if io=="On"
	return false if io=="Off"
end

def glass_acceleration?
	ga=@model.get_attribute(@dict,'glass_accel',@@glass_accel)
	return true if ga=="On"
	return false if ga=="Off"
end

def glass_acceleration=(value)
	if value
		@model.set_attribute(@dict,'glass_accel',"On")
	else
		@model.set_attribute(@dict,'glass_accel',"Off") 
	end
end

def lock_aspect?
	ga=@model.get_attribute(@dict,'lock_aspect',@@lock_aspect)
	return true if ga=="On"
	return false if ga=="Off"
end

def lock_aspect=(value)
	if value
		@model.set_attribute(@dict,'lock_aspect',"On")
	else
		@model.set_attribute(@dict,'lock_aspect',"Off") 
	end
end


def vignetting?
	val=@model.get_attribute(@dict,'vignetting',@@vignetting)
	return true if val=="On"
	return false if val=="Off"
end

def vignetting=(value)
	if value
		@model.set_attribute(@dict,'vignetting',"On")
	else
		@model.set_attribute(@dict,'vignetting',"Off") 
	end
end

def supersample_factor=(value)
	@model.set_attribute(@dict,'supersample_factor',value)
end

def supersample_factor
	@model.get_attribute(@dict,'supersample_factor',@@supersample_factor)
end

def sun_layer
	@model.get_attribute(@dict,'sun_layer',@@sun_layer)
end

def sun_layer=(value)
	@model.set_attribute(@dict,'sun_layer',value)
end

def sky_layer
	@model.get_attribute(@dict,'sky_layer',@@sky_layer)
end

def sky_layer=(value)
	@model.set_attribute(@dict,'sky_layer',value)
end

def env_map_layer
	#@model.get_attribute(@dict,'env_map_layer',@@env_map_layer)
	bg_mat=IndigoMaterial.find(self.bg_material)
	if bg_mat!=nil
		return bg_mat.layer
	else
		return 0
	end
	
end

def env_map_layer=(value)
	@model.set_attribute(@dict,'env_map_layer',value)
end

def store_texture(path)
	#p "storing #{path}"
	model_textures=self.get_model_textures
	unless model_textures.index(path)  #check if the path is already stored
		model_textures.push(path)
	end
	@model.set_attribute(@dict,'model_textures',model_textures)
	
end

def get_model_textures
	model_textures=@model.get_attribute(@dict,'model_textures',@@model_textures)
	#p "model textures = #{model_textures}"
	#valid_model_textures=model_textures.find_all {|path| FileTest.exist?(path)}  #make sure the files are valid
	valid_model_textures=model_textures
	@model.set_attribute(@dict,'model_textures',valid_model_textures)
	#p "valid model textures"
	#p valid_model_textures
	return valid_model_textures
end

def get_camera_response_functions
	resources_dir = SkIndigo.get_resource_dir_path
	cam_data_path = File.join(resources_dir, "data", "camera_response_functions")
	functions = Dir.entries(cam_data_path)
	functions.delete(".")
	functions.delete("..")
	functions.delete("source.txt")
	return functions
end

def frame_upload_period
	@model.get_attribute(@dict,'frame_upload_period',@@frame_upload_period)
end

def frame_upload_period=(value)
	@model.set_attribute(@dict,'frame_upload_period',value)
end

def network_mode
	@model.get_attribute(@dict,'network_mode',@@network_mode)
end

def network_mode=(value)
	@model.set_attribute(@dict,'network_mode',value.to_i)
end

def cam_resp_func
	@model.get_attribute(@dict,'cam_resp_func',@@cam_resp_func)
end

def cam_resp_func=(value)
	@model.set_attribute(@dict,'cam_resp_func',value)
end

def light_layer_names
	@model.get_attribute(@dict,'layer_names',@@light_layer_names)
end

def light_layer_names=(value)
	@model.set_attribute(@dict,'layer_names',value)
end

def sun_pos_override?
	@model.get_attribute(@dict,'sun_dir_override',@@sun_dir_override)
end

def sun_pos_override=(value)
	@model.set_attribute(@dict,'sun_dir_override',value)
end

def sun_dir
	@model.get_attribute(@dict,'sun_dir',@@sun_dir)
end

def sun_dir=(value)
	@model.set_attribute(@dict,'sun_dir',value)
end

def bg_luminance
	@model.get_attribute(@dict,'bg_luminance',@@bg_luminance)
end

def bg_luminance=(value)
	@model.set_attribute(@dict,'bg_luminance',value)
end

def bg_weight
	@model.get_attribute(@dict,'bg_weight',@@bg_weight)
end

def bg_weight=(value)
	@model.set_attribute(@dict,'bg_weight',value)
end

def sunsky_weight
	@model.get_attribute(@dict,'sunsky_weight',@@sunsky_weight)
end

def sunsky_weight=(value)
	@model.set_attribute(@dict,'sunsky_weight',value)
end

def bg_sun?
	val=@model.get_attribute(@dict,'bg_sun',@@bg_sun)
	return true if val=="On"
	return false if val=="Off"
end

def bg_sun=(value)
	if value
		@model.set_attribute(@dict,'bg_sun',"On")
	else
		@model.set_attribute(@dict,'bg_sun',"Off") 
	end
end

def bg_material
	@model.get_attribute(@dict,'bg_material',"")
end

def bg_material=(value)
	@model.set_attribute(@dict,'bg_material',value)
end

def use_gpu?
	value=@model.get_attribute(@dict,'use_gpu',@@use_gpu)
	return true if value=="On"
	return false if value=="Off"
end

def use_gpu=(value)
	if value
		@model.set_attribute(@dict,'use_gpu',"On")
	else
		@model.set_attribute(@dict,'use_gpu',"Off") 
	end
end

def cull_geometry?
	value=@model.get_attribute(@dict,'cull_geometry',@@cull_geometry)
	return true if value=="On"
	return false if value=="Off"
end

def cull_geometry=(value)
	if value
		@model.set_attribute(@dict,'cull_geometry',"On")
	else
		@model.set_attribute(@dict,'cull_geometry',"Off") 
	end
end

def foreground_alpha?
	value=@model.get_attribute(@dict,'foreground_alpha',@@foreground_alpha)
	return true if value=="On"
	return false if value=="Off"
end

def foreground_alpha=(value)
	@model.set_attribute(@dict,'foreground_alpha', value ? "On" : "Off")
end

def clamp_contributions?
	value = @model.get_attribute(@dict, 'clamp_contributions', @@clamp_contributions)
	return value == "On"
end

def clamp_contributions=(value)
	@model.set_attribute(@dict, 'clamp_contributions', value ? "On" : "Off")
end

def max_contribution
	@model.get_attribute(@dict, 'max_contribution', @@max_contribution)
end

def max_contribution=(value)
	@model.set_attribute(@dict, 'max_contribution', value)
end

def gpu_max_depth
	@model.get_attribute(@dict, 'gpu_max_depth', @@gpu_max_depth)
end

def gpu_max_depth=(value)
	@model.set_attribute(@dict, 'gpu_max_depth', value)
end

def camera_type
	@model.get_attribute(@dict,'camera_type',@@camera_type)
end

def camera_type=(value)
	@model.set_attribute(@dict,'camera_type',value)
end


def world_scale
	return Indigo.scale
end

def world_scale=(value)
	Indigo::scale=value.to_f
end

def sky_model
	@model.get_attribute(@dict,'sky_model',@@sky_model)
end

def sky_model=(value)
	@model.set_attribute(@dict,'sky_model',value)
end
######
def store_settings

dicts=@model.attribute_dictionaries
if dicts
	dict=dicts[@dict]
	if dict
		dict.each_pair {|key,value|
			Sketchup.write_default("SkIndigoDefaults",key,value)
		}
	end
	return true
else
	return false
end

end

####


end #class 
